' 2009 IDesign Inc.
'Questions? Comments? go to 
'http://www.idesign.net


Imports Microsoft.VisualBasic
Imports System
Imports System.ServiceModel
Imports System.Diagnostics
Imports System.ServiceModel.Channels

Namespace ServiceModelEx
    Public MustInherit Class DuplexClientBase(Of T As Class, C)
        Inherits DuplexClientBase(Of T)
        Shared Sub New()
            VerifyCallback()
        End Sub
        Friend Shared Sub VerifyCallback()
            Dim contractType As Type = GetType(T)
            Dim callbackType As Type = GetType(C)
            Dim attributes() As Object = contractType.GetCustomAttributes(GetType(ServiceContractAttribute), False)
            If attributes.Length <> 1 Then
                Throw New InvalidOperationException("Type of " & contractType.ToString & " is not a service contract")
            End If
            Dim serviceContractAttribute As ServiceContractAttribute = TryCast(attributes(0), ServiceContractAttribute)
            If callbackType IsNot serviceContractAttribute.CallbackContract Then
                Throw New InvalidOperationException("Type of " & callbackType.ToString & " is not configured as callback contract for " & contractType.ToString)
            End If
        End Sub
        Protected Sub New(ByVal context As InstanceContext(Of C))
            MyBase.New(context.Context)
        End Sub
        Protected Sub New(ByVal context As InstanceContext(Of C), ByVal endpointName As String)
            MyBase.New(context.Context, endpointName)
        End Sub
        Protected Sub New(ByVal context As InstanceContext(Of C), ByVal binding As Binding, ByVal remoteAddress As EndpointAddress)
            MyBase.New(context.Context, binding, remoteAddress)
        End Sub
        Protected Sub New(ByVal context As InstanceContext(Of C), ByVal endpointName As String, ByVal remoteAddress As EndpointAddress)
            MyBase.New(context.Context, endpointName, remoteAddress)
        End Sub
        Protected Sub New(ByVal context As InstanceContext(Of C), ByVal endpointName As String, ByVal remoteAddress As String)
            MyBase.New(context.Context, endpointName, remoteAddress)
        End Sub

        Protected Sub New(ByVal callback As C)
            MyBase.New(callback)
        End Sub
        Protected Sub New(ByVal callback As C, ByVal endpointName As String)
            MyBase.New(callback, endpointName)
        End Sub
        Protected Sub New(ByVal callback As C, ByVal binding As Binding, ByVal remoteAddress As EndpointAddress)
            MyBase.New(callback, binding, remoteAddress)
        End Sub
        Protected Sub New(ByVal callback As C, ByVal endpointName As String, ByVal remoteAddress As EndpointAddress)
            MyBase.New(callback, endpointName, remoteAddress)
        End Sub
        Protected Sub New(ByVal calback As C, ByVal endpointName As String, ByVal remoteAddress As String)
            MyBase.New(calback, endpointName, remoteAddress)
        End Sub
    End Class
End Namespace
