﻿' 2009 IDesign Inc.
'Questions? Comments? go to 
'http://www.idesign.net


Imports Microsoft.VisualBasic
Imports System
Imports System.ServiceModel
Imports System.ServiceModel.Channels
Imports ServiceModelEx
Imports System.Reflection
Imports Microsoft.ServiceBus
Imports System.ServiceModel.Security
Imports System.Diagnostics
Imports System.Security.Cryptography.X509Certificates
Imports System.ServiceModel.Description

Namespace ServiceModelEx.ServiceBus
   Public MustInherit Class OneWayClientBase(Of T As Class)
	   Inherits ServiceBusClientBase(Of T)
	  'Load service certificate from config 
	  Public Sub New(ByVal username As String, ByVal password As String)
		  MyBase.New(username,password)
	  End Sub
	  Public Sub New(ByVal endpointName As String, ByVal username As String, ByVal password As String)
		  MyBase.New(endpointName,username,password)
	  End Sub
	  Public Sub New(ByVal binding As NetOnewayRelayBinding, ByVal remoteAddress As EndpointAddress, ByVal username As String, ByVal password As String)
		  MyBase.New(binding,remoteAddress,username,password)
	  End Sub

	  'Load service certificate from config and anonymous
	  Public Sub New()
	  End Sub
	  Public Sub New(ByVal endpointName As String)
		  MyBase.New(endpointName)
	  End Sub
	  Public Sub New(ByVal binding As NetOnewayRelayBinding, ByVal remoteAddress As EndpointAddress)
		  MyBase.New(binding,remoteAddress)
	  End Sub
	  Protected ReadOnly Property ServiceBusCredentialBehavior() As TransportClientEndpointBehavior
		 Get
			Return Endpoint.Behaviors.Find(Of TransportClientEndpointBehavior)()
		 End Get
	  End Property
	  Protected Overrides Function CreateChannel() As T
		 Dim behavior As ClientCredentials = Endpoint.Behaviors.Find(Of ClientCredentials)()
		 If behavior.ServiceCertificate.DefaultCertificate Is Nothing AndAlso behavior.ServiceCertificate.ScopedCertificates.Count = 0 Then
			SetServiceCertificate()
		 End If
		 Return MyBase.CreateChannel()
	  End Function
	  Protected Sub SetServiceCertificate()
		 SetServiceCertificate("",StoreLocation.LocalMachine,StoreName.My)
	  End Sub

	  Public Sub SetServiceCertificate(ByVal serviceCert As String)
		 SetServiceCertificate(serviceCert,StoreLocation.LocalMachine,StoreName.My)
	  End Sub
	  Public Sub SetServiceCertificate(ByVal serviceCert As String, ByVal location As StoreLocation, ByVal storeName As StoreName)
		 If serviceCert Is String.Empty Then
			serviceCert = ServiceBusHelper.ExtractSolution(Endpoint.Address.Uri)
		 End If
		 SetServiceCertificate(serviceCert,location,storeName,X509FindType.FindBySubjectName)
	  End Sub
	  Public Sub SetServiceCertificate(ByVal findValue As Object, ByVal location As StoreLocation, ByVal storeName As StoreName, ByVal findType As X509FindType)
		 Dim behavior As ClientCredentials = Endpoint.Behaviors.Find(Of ClientCredentials)()
		 behavior.ServiceCertificate.SetDefaultCertificate(location,storeName,findType,findValue)
		 If Endpoint.Address.Identity Is Nothing Then
			Dim address As Uri = Endpoint.Address.Uri
			Dim identity As EndpointIdentity = New DnsEndpointIdentity(findValue.ToString())
			Endpoint.Address = New EndpointAddress(address,identity)
		 End If
	  End Sub

	  Protected Overrides Sub ConfigureForServiceBus()
		 Debug.Assert(TypeOf Endpoint.Binding Is NetOnewayRelayBinding,"Must use the NetOnewayRelayBinding")
		 MyBase.ConfigureForServiceBus()
	  End Sub
	  Protected Overrides Sub ConfigureForServiceBus(ByVal username As String, ByVal password As String)
		 Debug.Assert(TypeOf Endpoint.Binding Is NetOnewayRelayBinding,"Must use the NetOnewayRelayBinding")
		 MyBase.ConfigureForServiceBus(username,password)
	  End Sub
   End Class
End Namespace