﻿' 2009 IDesign Inc.
'Questions? Comments? go to 
'http://www.idesign.net


Imports Microsoft.VisualBasic
Imports System
Imports System.ServiceModel
Imports System.ServiceModel.Channels
Imports ServiceModelEx
Imports Microsoft.ServiceBus
Imports System.ServiceModel.Security
Imports System.Diagnostics

Namespace ServiceModelEx.ServiceBus
   Public MustInherit Class ServiceBusDuplexClientBase(Of T As Class, C)
	   Inherits DuplexClientBase(Of T,C)
	   Implements IServiceBusProperties
	  Public Sub New(ByVal callback As C)
		  MyBase.New(callback)
		 ConfigureForServiceBus()
	  End Sub
	  Public Sub New(ByVal callback As C, ByVal endpointName As String)
		  MyBase.New(callback,endpointName)
		 ConfigureForServiceBus()
	  End Sub
	  Public Sub New(ByVal callback As C, ByVal binding As NetTcpRelayBinding, ByVal remoteAddress As EndpointAddress)
		  MyBase.New(callback,binding,remoteAddress)
		 ConfigureForServiceBus()
	  End Sub
	  Public Sub New(ByVal callback As C, ByVal username As String, ByVal password As String)
		  MyBase.New(callback)
		 ConfigureForServiceBus(username,password)
	  End Sub
	  Public Sub New(ByVal callback As C, ByVal endpointName As String, ByVal username As String, ByVal password As String)
		  MyBase.New(callback,endpointName)
		 ConfigureForServiceBus(username,password)
	  End Sub
	  Public Sub New(ByVal callback As C, ByVal binding As NetTcpRelayBinding, ByVal remoteAddress As EndpointAddress, ByVal username As String, ByVal password As String)
		  MyBase.New(callback,binding,remoteAddress)
		 ConfigureForServiceBus(username,password)
	  End Sub
	  Protected Overridable Sub ConfigureForServiceBus()
		 Debug.Assert(TypeOf Endpoint.Binding Is NetTcpRelayBinding)
		 ClientCredentials.ServiceCertificate.Authentication.CertificateValidationMode = X509CertificateValidationMode.PeerTrust
		 ServiceBusHelper.ConfigureBinding(Endpoint.Binding)
	  End Sub
	  Protected Overridable Sub ConfigureForServiceBus(ByVal username As String, ByVal password As String)
		 Debug.Assert(TypeOf Endpoint.Binding Is NetTcpRelayBinding)
		 ClientCredentials.UserName.UserName = username
		 ClientCredentials.UserName.Password = password
		 ClientCredentials.ServiceCertificate.Authentication.CertificateValidationMode = X509CertificateValidationMode.PeerTrust
		 ServiceBusHelper.ConfigureBinding(Endpoint.Binding,False)
	  End Sub

	  Private Property Credential() As TransportClientEndpointBehavior Implements IServiceBusProperties.Credential
		 Get
			Return Endpoint.Behaviors.Find(Of TransportClientEndpointBehavior)()
		 End Get
		 Set(ByVal value As TransportClientEndpointBehavior)
			Debug.Assert(Endpoint.Behaviors.Contains(GetType(TransportClientEndpointBehavior)) = False)
			Endpoint.Behaviors.Add(value)
		 End Set
	  End Property

	  Private ReadOnly Property Addresses() As Uri() Implements IServiceBusProperties.Addresses
		 Get
			Return New Uri(){Endpoint.Address.Uri}
		 End Get
	  End Property
   End Class
End Namespace