﻿' 2009 IDesign Inc.
'Questions? Comments? go to 
'http://www.idesign.net


Imports Microsoft.VisualBasic
Imports System
Imports System.ServiceModel
Imports System.ServiceModel.Channels
Imports ServiceModelEx
Imports Microsoft.ServiceBus
Imports System.ServiceModel.Security
Imports System.ServiceModel.Description
Imports System.Diagnostics

Namespace ServiceModelEx.ServiceBus
   Public MustInherit Class ServiceBusClientBase(Of T As Class)
	   Inherits ClientBase(Of T)
	   Implements IServiceBusProperties
	  Public Sub New()
		 ConfigureForServiceBus()
	  End Sub
	  Public Sub New(ByVal endpointName As String)
		  MyBase.New(endpointName)
		 ConfigureForServiceBus()
	  End Sub
	  Public Sub New(ByVal binding As Binding, ByVal remoteAddress As EndpointAddress)
		  MyBase.New(binding,remoteAddress)
		 ConfigureForServiceBus()
	  End Sub
	  Public Sub New(ByVal username As String, ByVal password As String)
		 ConfigureForServiceBus(username,password)
	  End Sub
	  Public Sub New(ByVal endpointName As String, ByVal username As String, ByVal password As String)
		  MyBase.New(endpointName)
		 ConfigureForServiceBus(username,password)
	  End Sub
	  Public Sub New(ByVal binding As Binding, ByVal remoteAddress As EndpointAddress, ByVal username As String, ByVal password As String)
		  MyBase.New(binding,remoteAddress)
		 ConfigureForServiceBus(username,password)
	  End Sub
	  Protected Overridable Sub ConfigureForServiceBus()
		 ClientCredentials.ServiceCertificate.Authentication.CertificateValidationMode = X509CertificateValidationMode.PeerTrust
		 ServiceBusHelper.ConfigureBinding(Endpoint.Binding)
	  End Sub
	  Protected Overridable Sub ConfigureForServiceBus(ByVal username As String, ByVal password As String)
		 ClientCredentials.UserName.UserName = username
		 ClientCredentials.UserName.Password = password
		 ClientCredentials.ServiceCertificate.Authentication.CertificateValidationMode = X509CertificateValidationMode.PeerTrust
		 ServiceBusHelper.ConfigureBinding(Endpoint.Binding,False)
	  End Sub
	  Protected Overrides Function CreateChannel() As T
		 If Endpoint.Address.Identity Is Nothing Then
			Dim solution As String = ServiceBusHelper.ExtractSolution(Endpoint.Address.Uri)
			Dim address As Uri = Endpoint.Address.Uri
			Dim identity As EndpointIdentity = New DnsEndpointIdentity(solution)
			Endpoint.Address = New EndpointAddress(address,identity)
		 End If
		 Return MyBase.CreateChannel()
	  End Function
	  Private Property Credential() As TransportClientEndpointBehavior Implements IServiceBusProperties.Credential
		 Get
			Return Endpoint.Behaviors.Find(Of TransportClientEndpointBehavior)()
		 End Get
		 Set(ByVal value As TransportClientEndpointBehavior)
			Debug.Assert(Endpoint.Behaviors.Contains(GetType(TransportClientEndpointBehavior)) = False)
			Endpoint.Behaviors.Add(value)
		 End Set
	  End Property

	  Private ReadOnly Property Addresses() As Uri() Implements IServiceBusProperties.Addresses
		 Get
			Return New Uri(){Endpoint.Address.Uri}
		 End Get
	  End Property
   End Class
End Namespace