﻿' 2009 IDesign Inc.
'Questions? Comments? go to 
'http://www.idesign.net


Imports Microsoft.VisualBasic
Imports System
Imports System.ServiceModel
Imports System.ServiceModel.Description
Imports Microsoft.ServiceBus
Imports System.Collections.ObjectModel
Imports System.Diagnostics
Imports System.ServiceModel.Configuration
Imports System.Configuration
Imports System.ServiceModel.Channels

Namespace ServiceModelEx.ServiceBus
    Public Module ServiceBusHelper
        Private Sub SetBehavior(ByVal endpoints As Collection(Of ServiceEndpoint), ByVal credential As TransportClientEndpointBehavior)
            For Each endpoint As ServiceEndpoint In endpoints
                If TypeOf endpoint.Binding Is NetTcpRelayBinding OrElse TypeOf endpoint.Binding Is WSHttpRelayBinding OrElse TypeOf endpoint.Binding Is NetOnewayRelayBinding Then
                    endpoint.Behaviors.Add(credential)
                End If
            Next endpoint
        End Sub
        Friend Sub ConfigureBinding(ByVal binding As Binding)
            ConfigureBinding(binding, True)
        End Sub
        Friend Sub ConfigureBinding(ByVal binding As Binding, ByVal anonymous As Boolean)
            If TypeOf binding Is NetTcpRelayBinding Then
                Dim tcpBinding As NetTcpRelayBinding = CType(binding, NetTcpRelayBinding)
                tcpBinding.Security.Mode = EndToEndSecurityMode.Message
                If anonymous Then
                    tcpBinding.Security.Message.ClientCredentialType = MessageCredentialType.None
                Else
                    tcpBinding.Security.Message.ClientCredentialType = MessageCredentialType.UserName
                End If

                tcpBinding.ConnectionMode = TcpRelayConnectionMode.Hybrid
                tcpBinding.ReliableSession.Enabled = True

                Return
            End If
            If TypeOf binding Is WSHttpRelayBinding Then
                Dim wsBinding As WSHttpRelayBinding = CType(binding, WSHttpRelayBinding)
                wsBinding.Security.Mode = EndToEndSecurityMode.Message
                If anonymous Then
                    wsBinding.Security.Message.ClientCredentialType = MessageCredentialType.None
                Else
                    wsBinding.Security.Message.ClientCredentialType = MessageCredentialType.UserName
                End If
                wsBinding.ReliableSession.Enabled = True

                Return
            End If
            If TypeOf binding Is NetOnewayRelayBinding Then
                Dim onewayBinding As NetOnewayRelayBinding = CType(binding, NetOnewayRelayBinding)
                onewayBinding.Security.Mode = EndToEndSecurityMode.Message
                If anonymous Then
                    onewayBinding.Security.Message.ClientCredentialType = MessageCredentialType.None
                Else
                    onewayBinding.Security.Message.ClientCredentialType = MessageCredentialType.UserName
                End If
                Return
            End If
            Throw New InvalidOperationException(binding.GetType().ToString & " is unsupported")
        End Sub

        Public Function ExtractSolution(ByVal address As Uri) As String
            Return address.Host.Split("."c)(0)
        End Function

        Public Function ExtractSolutionFromConfig(ByVal endpointName As String) As String
            Dim config As Configuration = ConfigurationManager.OpenExeConfiguration(ConfigurationUserLevel.None)
            Dim sectionGroup As ServiceModelSectionGroup = ServiceModelSectionGroup.GetSectionGroup(config)

            For Each endpointElement As ChannelEndpointElement In sectionGroup.Client.Endpoints
                If endpointElement.Name = endpointName Then
                    Return ExtractSolution(endpointElement.Address)
                End If
            Next endpointElement
            Return Nothing
        End Function
        Public Function ExtractSolutionFromConfig(ByVal serviceType As Type) As String
            Dim config As Configuration = ConfigurationManager.OpenExeConfiguration(ConfigurationUserLevel.None)
            Dim sectionGroup As ServiceModelSectionGroup = ServiceModelSectionGroup.GetSectionGroup(config)

            For Each serviceElement As ServiceElement In sectionGroup.Services.Services
                If serviceElement.Name = serviceType.ToString() Then
                    Return ExtractSolution(serviceElement.Endpoints(0).Address)
                End If
            Next serviceElement
            Return Nothing
        End Function
    End Module
End Namespace





